package com.company;

public class smallBoards {
    // a two dimensional array that saves the board's coordinate
    private byte[][] boardsCoordinate;

    /**
     * Creates a smallBoard with it's "boards coordinate"
     */
    public smallBoards(){
        boardsCoordinate = new byte[3][3];
    }

    /**
     * gets a x and a y and returns the number of board that this x and y belongs to.
     * @param x the x of the coordinate
     * @param y the y of the coordinate
     * @return the boardNumber
     */
    public byte whichBoard(byte x, byte y){
        if ((x >= 0) && (x < 3) && (y >= 0) && (y < 3))
            return 1;
        if ((x >= 3) && (x < 6) && (y >= 0) && (y < 3))
            return 2;
        if ((x >= 0) && (x < 3) && (y >= 3) && (y < 6))
            return 3;
        if ((x >= 3) && (x < 6) && (y >= 3) && (y < 6))
            return 4;
        // returns 0 if the x and y don't belong to any of small boards
        return 0;
    }

    /**
     * this method rotates the small board 90 degrees clockwise
     */
    public void rotate(){
        byte tmp = boardsCoordinate[2][0];
        boardsCoordinate[2][0] = boardsCoordinate[0][0];
        byte tmp1 = boardsCoordinate[2][2];
        boardsCoordinate[2][2] = tmp;
        byte tmp2 = boardsCoordinate[0][2];
        boardsCoordinate[0][2] = tmp1;
        boardsCoordinate[0][0] = tmp2;

        tmp = boardsCoordinate[1][0];
        boardsCoordinate[1][0] = boardsCoordinate[0][1];
        tmp1 = boardsCoordinate[2][1];
        boardsCoordinate[2][1] = tmp;
        tmp2 = boardsCoordinate[1][2];
        boardsCoordinate[1][2] = tmp1;
        boardsCoordinate[0][1] = tmp2;

    }

    /**
     * gets a x and a y of the board and playerNumber to check if
     * the coordinate doesn't belong to any players
     * @param x is the x of the coordinate
     * @param y is the x of the coordinate
     * @param playerNumber is the number of player
     */
    public void addDiscToTheBoard(byte x, byte y, byte playerNumber){
        if (boardsCoordinate[x][y] == 0)
            boardsCoordinate[x][y] = playerNumber;
    }
}
